
#include "PushButton.h"
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This generated code may be freely used for both private and commercial use
   provided this copyright is maintained.
*/

PushButton::PushButton(char _cmd, pfodDwgs *_dwgsPtr) {
  buttonCmd = _cmd;
  dwgsPtr = _dwgsPtr;
  z_idx = pfodDwgs::reserveIdx(1);
  baseCol = 0; baseRow = 0; baseScaling = 1.0f;
  onState = false;
}

void PushButton::setBase(int c, int r, float scale) {
  baseCol = c;
  baseRow = r;
  baseScaling = scale;
}


char PushButton::getCmd() {
  return buttonCmd;
}


void PushButton::setOnState(bool _state) {
  onState = _state;
}

bool PushButton::isOn() {
  return onState;
}

void PushButton::draw() {
  dwgsPtr->pushZero(baseCol, baseRow, baseScaling);
  dwgsPtr->rectangle().filled().rounded().centered().size(8, 8)
  .color(dwgsPtr->WHITE).send();
  dwgsPtr->circle().filled().radius(3.0)
  .color(dwgsPtr->GREY).send();
  dwgsPtr->touchZone().cmd(buttonCmd).size(6, 6).centered().filter(dwgsPtr->TOUCH)
  .send();
  dwgsPtr->touchAction()
  .cmd(buttonCmd)
  .action( // create the action
    dwgsPtr->circle().filled().idx(z_idx + 1).radius(4).color(dwgsPtr->GREY) //
  ).send(); // send the touchAction
  update(); // update with current state
  dwgsPtr->popZero(); // pop Base push and scale
}

void PushButton::update() {
  if (onState) {
    dwgsPtr->circle().filled().idx(z_idx).radius(2.6)
    .color(dwgsPtr->YELLOW).send();
  } else {

    dwgsPtr->circle().filled().idx(z_idx).radius(2.6)
    .color(dwgsPtr->BLACK).send();
  }

}


